import React, { Component } from 'react';
import PdfJsLib from 'pdfjs-dist';
import PropTypes from 'prop-types';

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

var classCallCheck = _classCallCheck;

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

var createClass = _createClass;

function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

var _typeof_1 = createCommonjsModule(function (module) {
function _typeof2(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof2 = function _typeof2(obj) { return typeof obj; }; } else { _typeof2 = function _typeof2(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof2(obj); }

function _typeof(obj) {
  if (typeof Symbol === "function" && _typeof2(Symbol.iterator) === "symbol") {
    module.exports = _typeof = function _typeof(obj) {
      return _typeof2(obj);
    };
  } else {
    module.exports = _typeof = function _typeof(obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : _typeof2(obj);
    };
  }

  return _typeof(obj);
}

module.exports = _typeof;
});

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

var assertThisInitialized = _assertThisInitialized;

function _possibleConstructorReturn(self, call) {
  if (call && (_typeof_1(call) === "object" || typeof call === "function")) {
    return call;
  }

  return assertThisInitialized(self);
}

var possibleConstructorReturn = _possibleConstructorReturn;

var getPrototypeOf = createCommonjsModule(function (module) {
function _getPrototypeOf(o) {
  module.exports = _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

module.exports = _getPrototypeOf;
});

var setPrototypeOf = createCommonjsModule(function (module) {
function _setPrototypeOf(o, p) {
  module.exports = _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

module.exports = _setPrototypeOf;
});

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) setPrototypeOf(subClass, superClass);
}

var inherits = _inherits;

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css = ".index_container__3XCPZ {\n  position: absolute;\n  top: 0;\n  left: 0;\n  right: 0;\n  bottom: 0;\n  background-color: #404040;\n  padding: 10px;\n  display: flex;\n  flex-direction: column;\n}\n.index_container__3XCPZ .index_pdfView__3EFQ3 {\n  overflow: scroll;\n  flex: 1;\n}\n.index_container__3XCPZ .index_pdfView__3EFQ3 .index_page__1NfQA {\n  margin: 0 auto;\n}\n.index_container__3XCPZ .index_pdfView__3EFQ3 .index_page__1NfQA + .index_page__1NfQA {\n  margin-top: 8px;\n}\n";
var styles = {"container":"index_container__3XCPZ","pdfView":"index_pdfView__3EFQ3","page":"index_page__1NfQA"};
styleInject(css);

var wrapper = 'div-wrapper-';
var prePage = 'canvas-page-';

var index =
/*#__PURE__*/
function (_Component) {
  inherits(index, _Component);

  function index() {
    var _getPrototypeOf2;

    var _this;

    classCallCheck(this, index);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = possibleConstructorReturn(this, (_getPrototypeOf2 = getPrototypeOf(index)).call.apply(_getPrototypeOf2, [this].concat(args)));
    _this.state = {
      numPages: 0,
      currentPage: 1,
      pdf: null,
      pages: []
    };
    _this.pagesData = [];

    _this.renderPdf = function () {
      var _this$props = _this.props,
          url = _this$props.url,
          onPdfLoaded = _this$props.onPdfLoaded,
          onPageChange = _this$props.onPageChange,
          maxWidth = _this$props.maxWidth;

      if (!url) {
        return;
      }

      PdfJsLib.GlobalWorkerOptions.workerSrc = require('pdfjs-dist/build/pdf.worker.js');
      PdfJsLib.getDocument(url).then(function (pdf) {
        var _pdfInfo = pdf._pdfInfo;
        var numPages = _pdfInfo.numPages;
        onPdfLoaded && onPdfLoaded();
        var pages = [];

        for (var i = 0; i < numPages; i += 1) {
          pages.push({
            id: i
          });

          _this.pagesData.push({
            rendered: false,
            redering: false,
            singlePageHeight: 0
          });
        }

        onPageChange && onPageChange(1, _this.pagesData.length); // initialize

        _this.setState({
          pdf: pdf,
          pages: pages
        }, function () {
          // resize every page
          var pdfView = document.getElementById('pdfView');
          var contentWidth = pdfView.clientWidth;

          var _loop = function _loop(j) {
            pdf.getPage(j + 1).then(function (page) {
              console.log(assertThisInitialized(_this));
              var scale = 1; // origin

              var oldViewport = page.getViewport(scale);

              if (contentWidth > maxWidth) {
                scale = maxWidth / oldViewport.width;
              } else {
                scale = contentWidth / oldViewport.width;
              }

              var viewport = page.getViewport(scale); // wrapper

              var wrapperView = _this[wrapper + j];
              wrapperView.style.width = "".concat(viewport.width, "px");
              wrapperView.style.height = "".concat(viewport.height, "px"); // canvas

              var canvas = _this[prePage + j];
              canvas.width = viewport.width;
              canvas.height = viewport.height;
              canvas.setAttribute('data-scale', scale); // update each page's height

              _this.pagesData[j].singlePageHeight = viewport.height + 8; // first render

              if (j === _this.pagesData.length - 1) {
                _this.firstRender();
              }
            });
          };

          for (var j = 0; j < pages.length; j += 1) {
            _loop(j);
          } // add observer for monitoring scroll-height


          _this.addObserverForPdfContent();
        });
      });
    };

    _this.firstRender = function () {
      var _this$state = _this.state,
          pdf = _this$state.pdf,
          numPages = _this$state.numPages; // calculate page's height

      var content = document.getElementById('pdfView');
      var visiblePageNum = _this.getPageNumByHeight(content.clientHeight) + 1;

      for (var idx = 0; idx < visiblePageNum; idx += 1) {
        if (idx > numPages) {
          return;
        } else {
          _this.renderPdfByPageNum(idx, pdf);
        }
      }
    };

    _this.addObserverForPdfContent = function () {
      var _this$state2 = _this.state,
          pdf = _this$state2.pdf,
          currentPage = _this$state2.currentPage;
      var onPageChange = _this.props.onPageChange;
      var content = document.getElementById('pdfView');
      content.addEventListener('scroll', function (e) {
        var pageNum = _this.getPageNumByHeight(content.scrollTop);

        if (pageNum + 1 !== currentPage) {
          _this.setState({
            currentPage: pageNum + 1
          });

          onPageChange && onPageChange(pageNum + 1, _this.pagesData.length);
        } // redo render to avoid render failed


        if (pageNum > 0) {
          _this.renderPdfByPageNum(pageNum, pdf);
        }

        _this.renderPdfByPageNum(pageNum + 1, pdf);
      });
    };

    _this.renderPdfByPageNum = function (pageNum, pdf) {
      if (pageNum > _this.pagesData.length - 1) {
        return;
      } // single page data


      var singlePageData = _this.pagesData[pageNum];

      if (!(singlePageData.rendering || singlePageData.rendered)) {
        pdf.getPage(pageNum + 1).then(function (page) {
          singlePageData.rendering = true; // get canvas

          var canvas = _this[prePage + pageNum];
          var scale = canvas.getAttribute('data-scale'); // canvas's scale

          var viewport = page.getViewport(scale);
          var context = canvas.getContext('2d');
          var renderContext = {
            canvasContext: context,
            viewport: viewport
          };
          page.render(renderContext).then(function () {
            singlePageData.rendered = true;
            singlePageData.rendering = false; // update

            console.log('page rendered');
          }).catch(function (error) {
            singlePageData.rendering = false;
          });
        }).catch(function (err) {
          console.log(err);
        });
      }
    };

    _this.getPageNumByHeight = function (height) {
      var pdf = _this.state.pdf;

      if (!pdf) {
        return;
      }

      var totalHeight = 0;
      var pageIndex = 0;

      for (var i = 0; i < _this.pagesData.length; i += 1) {
        totalHeight += _this.pagesData[i].singlePageHeight;

        if (totalHeight >= height) {
          pageIndex = i;
          break;
        }
      }

      return pageIndex;
    };

    _this.calculateScrollHeightByPageNum = function (pageNum, topNum, content) {
      console.log(topNum);
      var totalHeight = 0;

      for (var i = 0; i <= pageNum; i += 1) {
        var currentPageHeight = _this.pagesData[i].singlePageHeight;

        if (pageNum > 0 && i != pageNum - 1) {
          totalHeight += currentPageHeight;
        } else {
          totalHeight += currentPageHeight - topNum - content.clientHeight / 2;
        }
      }

      return totalHeight;
    };

    return _this;
  }

  createClass(index, [{
    key: "removeObserver",
    value: function removeObserver() {
      var content = document.getElementById('pdfView');
      content.removeEventListener('scroll', null);
    } // render any of page pdf

  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.renderPdf();
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.removeObserver();
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var pages = this.state.pages;
      return React.createElement("div", {
        className: styles.container
      }, React.createElement("div", {
        className: styles.pdfView,
        id: "pdfView"
      }, pages.map(function (item, idx) {
        return React.createElement("div", {
          className: styles.page,
          key: "page-content-".concat(idx),
          ref: function ref(element) {
            return _this2["".concat(wrapper).concat(idx)] = element;
          }
        }, React.createElement("canvas", {
          ref: function ref(element) {
            return _this2["".concat(prePage).concat(idx)] = element;
          },
          className: styles.layer
        }));
      })));
    }
  }]);

  return index;
}(Component);

index.propTypes = {
  url: PropTypes.string.isRequired,
  // pdf url
  onPageChange: PropTypes.func,
  // calls when page changes
  onPdfLoaded: PropTypes.func,
  maxWidth: PropTypes.number // max width of the viewport

};
index.defaultProps = {
  url: '',
  maxWidth: 1100
};

export default index;
